"use strict";

require("core-js/modules/es.object.assign.js");

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = FullCalendarComponent;

var _react = _interopRequireWildcard(require("react"));

var _react2 = _interopRequireDefault(require("@fullcalendar/react"));

var _daygrid = _interopRequireDefault(require("@fullcalendar/daygrid"));

var _timegrid = _interopRequireDefault(require("@fullcalendar/timegrid"));

var _interaction = _interopRequireDefault(require("@fullcalendar/interaction"));

var _bootstrap = _interopRequireDefault(require("@fullcalendar/bootstrap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function FullCalendarComponent(props) {
  const pluginsList = {
    'dayGridPlugin': _daygrid.default,
    'timeGridPlugin': _timegrid.default,
    'interactionPlugin': _interaction.default,
    'bootstrapPlugin': _bootstrap.default
  };
  const calenderRef = (0, _react.useRef)();
  const defaultProps = {
    themeSystem: 'bootstrap',
    plugins: [pluginsList.dayGridPlugin, pluginsList.timeGridPlugin, pluginsList.interactionPlugin],
    headerToolbar: {
      left: 'prev,next today',
      center: 'title',
      right: 'dayGridMonth,timeGridWeek,timeGridDay'
    },
    initialView: 'dayGridMonth',
    businessHours: [{
      daysOfWeek: [0, 1, 2, 3, 4, 5, 6],
      // Monday to Friday
      startTime: '00:00',
      // 8am
      endTime: '23:00' // 6pm

    }],
    droppable: false,
    editable: false,
    selectable: false,
    selectMirror: true,
    dayMaxEvents: true,
    weekends: true,
    events: [],
    initialEvents: [],
    monthDayrRedirect: true,
    eventClick: () => {},
    eventsSet: () => {},
    eventAdd: () => {},
    // (e) => { console.log('event', 'add', e) },
    eventChange: () => {},
    // (e) => { console.log('event', 'change', e) },
    eventRemove: () => {},
    eventDrop: () => {},
    // (e) => { console.log('event', 'drop', e) },
    eventContent: () => {},
    // (dayRenderInfo) => { console.log('day render', dayRenderInfo) },
    dateClick: e => {
      if (props.monthDayrRedirect || defaultProps.monthDayrRedirect) {
        const calendarApi = getRefernce().current.getApi(); // eslint-disable-line

        calendarApi.changeView('timeGridDay', e.date);
      }
    },
    customButtons: {}
  };

  const getPlugins = () => {
    const selectedPlugin = [];
    props.pluginslist.map(item => {
      if (pluginsList[item]) selectedPlugin.push(pluginsList[item]);
      return item;
    });
    return props.pluginslist && props.pluginslist.length > 0 ? selectedPlugin : defaultProps.plugins;
  };

  const getRefernce = () => {
    return props.calenderRef ? props.calenderRef : calenderRef;
  };

  const finalProps = _objectSpread(_objectSpread(_objectSpread({}, defaultProps), props), {}, {
    plugins: getPlugins()
  }); // console.log("finalProps", finalProps);


  return /*#__PURE__*/_react.default.createElement("div", {
    className: "calenderWrapper ".concat(finalProps.classWrapper || '')
  }, /*#__PURE__*/_react.default.createElement(_react2.default, _extends({
    ref: getRefernce()
  }, finalProps)));
}